function LibLoginService(requestDataSourceEngine){
    this.startSession = function(user) {
        var filter = [ {
            name: 'USER',
            value: user,
            operator: '='
        }, {
            name: 'IS_LOGGED',
            value: localStorage.getItem('IS_LOGGED') || false,
            operator: '='
        }, {
            name: 'LOGIN_TOKEN',
            value: localStorage.getItem('LOGIN_TOKEN'),
            operator: '='
        } ];

        return requestDataSourceEngine.getDataSource('lib#/lib_startSession', filter, 1, undefined, undefined, undefined, 120000)
            .then(function(data) {
                if(typeof data == 'string') {
                    return {
                        isError : true,
                        message : data
                    };
                }
                return data && data.dataset ? data.dataset.system : false;
            });
    };

    this.validateUser = function(cdOperator, password) {
        var filter = [ {
            name: 'USER',
            value: cdOperator,
            operator: '='
        }, {
            name: 'PASSWORD',
            value: password,
            operator: '='
        } ];

        return requestDataSourceEngine.getDataSource('login#/validateUser', filter);
    };

    this.logout = function() {
        return requestDataSourceEngine.getDataSource('lib#/lib_logout', [], 1, undefined, undefined, undefined, 120000);
    };

    this.getModulesVersion = function(){
        return requestDataSourceEngine.getDataSource('lib#/lib_getModulesVersion', []);
    };

    this.generateModulesVersionFile = function() {
        return requestDataSourceEngine.setDataSource('lib#/lib_generateModulesVersionFile', [ { changed: true } ]);
    };

    this.downloadModulesVersionFile = function(fileName) {
        var serviceUrl = window.serviceUrl;
        window.open(serviceUrl + "/lib_downloadModulesVersionFile?requestType=DataSet&dataset[0][FILE_NAME]=" + fileName);
    };
}

Configuration(function(ContextRegister){
    ContextRegister.register('LibLoginService', LibLoginService);
});

